// Pretty much the same as CircleFractal, except that we 
// keep track of the sizes of the circles rather than the
// number of recursive levels.  That way we can adaptively
// decide when to stop drawing circles, because they're so
// small that they don't contribute to the final drawing.

void setup()
{
  size( 500, 500 );
  fill( 128, 50 );
  stroke( 0 );
}

void makeDrawing( float diam )
{
  if ( diam < 2 ) {
    return;
  }

  ellipse( 0, 0, 150, 150 );
  float sc = map( mouseY, 0, height, 0, 0.99 );

  pushMatrix();
  rotate( map( mouseX, 0, width, 0, -radians( 60 ) ) );
  translate( 75, 0 );
  scale( sc );
  makeDrawing( diam * sc );
  popMatrix();
  pushMatrix();
  rotate( PI + map( mouseX, 0, width, 0, radians( 60 ) ) );
  translate( 75, 0 );
  scale( sc );
  makeDrawing( diam * sc );
  popMatrix();
}

void draw()
{
  background( 255 );
  translate( 250, 250 );
  scale( 1.5 );
  makeDrawing( 225 );
}