import peasy.*;

PShape tube;
PeasyCam cam;

int levels = 1;

void setup()
{
  size( 600, 600, P3D );
  tube = loadShape( "tube.obj" );
  
  cam = new PeasyCam( this, 100 );
}

void drawTubes( int levs )
{
  shape( tube );
  
  if( levs > 0 ) {
    for( int idx = 0; idx < 6; ++idx ) {
      pushMatrix();
      rotateZ( TWO_PI * idx / 6 );
      translate( 18, 0, 0 );
      rotateX( HALF_PI );
      scale( 0.4 );
      rotateZ( -0.01 * frameCount );
      drawTubes( levs - 1 );
      popMatrix();
    }
  }
}

void draw()
{
  background( 50 );
  lights();
  pointLight( 200, 200, 255, 0, 0, 20 );
  fill( 255 );
  pushMatrix();
  rotateX( 0.3 * PI );
  rotateZ( -0.01 * frameCount );
  scale( 1.6 );
  drawTubes( levels );
  popMatrix();
}

// A handy doodad for changing the recursive level interactively.
void keyPressed()
{
  if ( key == '-' ) {
    levels = max( 0, levels - 1 );
  } else if ( key == '=' ) {
    ++levels;
  }
}